/*
 * Simple but hopefully safer RPC service replacement
 *
 * Copright (C) 2000 <okir@caldera.de>
 */

#ifndef _RPC_AUTH_H
#define _RPC_AUTH_H

#include <sys/types.h>

#ifdef cplusplus
extern "C" {
#endif

#define MAX_AUTH_BYTES  400
#define MAXNETNAMELEN   255     /* maximum length of network user's name */
 
/*
 * Authentication info.  Opaque to client.
 */
struct opaque_auth {
	int		oa_flavor;	/* flavor of auth */
	void *		oa_base;	/* address of more auth stuff */
	unsigned int	oa_length;	/* not to exceed MAX_AUTH_BYTES */
};

 /*
  * Status returned from authentication check
   */
enum auth_stat {
	AUTH_OK = 0,
	AUTH_BADCRED = 1,	/* bogus credentials (seal broken) */
	AUTH_REJECTEDCRED = 2,	/* client should begin new session */
	AUTH_BADVERF = 3,	/* bogus verifier (seal broken) */
	AUTH_REJECTEDVERF = 4,	/* verifier expired or was replayed */
	AUTH_TOOWEAK = 5,	/* rejected due to security reasons */
};

/* Auth flavors we support */
#define AUTH_NONE	0
#define AUTH_NULL	0
#define AUTH_UNIX	1
#define AUTH_SYS	1

#ifdef cplusplus
}
#endif

#endif /* _RPC_AUTH_H */
