#ifndef _RPC_AUTH_UNIX_H
#define _RPC_AUTH_UNIX_H

#include <smallrpc/types.h>
#include <smallrpc/xdr.h>

#ifdef cplusplus
extern "C" {
#endif

#define AUTH_UNIX_MAX_MACHNAME	255
#define AUTH_UNIX_NGRPS		16

/*
 * Unix style credentials.
 */
struct authunix_parms {
	u_int32_t			aup_time;
	char *				aup_machname;
	u_int32_t			aup_uid;
	u_int32_t			aup_gid;
	u_int32_t			aup_len;
	u_int32_t *			aup_gids;
};

extern bool_t		xdr_authunix_parms(XDR *, struct authunix_parms *);

#ifdef cplusplus
}
#endif

#endif /* rpc/auth_unix.h */
