#ifndef _RPC_PMAP_PROT_H
#define _RPC_PMAP_PROT_H

#include <smallrpc/xdr.h>

#ifdef cplusplus
extern "C" {
#endif

#define PMAPPORT		111
#define PMAPPROG		100000
#define PMAPVERS		2
#define PMAPPROC_NULL		0
#define PMAPPROC_SET		1
#define PMAPPROC_UNSET		2
#define PMAPPROC_GETPORT	3
#define PMAPPROC_DUMP		4
#define PMAPPROC_CALLIT		5

struct pmap {
	u_int32_t		pm_prog;
	u_int32_t		pm_vers;
	u_int32_t		pm_prot;
	u_int32_t		pm_port;
};

struct pmaplist {
	struct pmap		pml_map;
	struct pmaplist *	pml_next;
};

extern bool_t			xdr_pmap(XDR *, struct pmap *);
extern bool_t			xdr_pmaplist(XDR *, struct pmaplist **);

#ifdef cplusplus
}
#endif

#endif /* rpc/pmap_prot.h */
