#ifndef _RPC_PMAP_RMT_H
#define _RPC_PMAP_RMT_H

#include <smallrpc/types.h>
#include <smallrpc/xdr.h>

#ifdef cplusplus
extern "C" {
#endif

struct rmtcallargs {
	u_int32_t		prog;
	u_int32_t		vers;
	u_int32_t		proc;
	unsigned int		arglen;
	void *			args;
	xdrproc_t		xdr_args;
};

struct rmtcallres {
	u_int32_t *		port_ptr;
	u_int32_t		resultslen;
	void *			results_ptr;
	xdrproc_t		xdr_results;
};

extern bool_t		xdr_rmtcall_args(XDR *, struct rmtcallargs *);
extern bool_t		xdr_rmtcallres(XDR *, struct rmtcallres *);

#ifdef cplusplus
}
#endif

#endif /* rpc/pmap_rmt.h */
