/*
 * Simple but hopefully safer RPC service replacement
 *
 * Copright (C) 2000 <okir@caldera.de>
 */

#ifndef _RPC_SVC_INT_H
#define _RPC_SVC_INT_H

#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include "svc.h"
#include "xdr.h"
#include "rpc_msg.h"

#ifdef cplusplus
extern "C" {
#endif

typedef struct _srvc {
	struct _srvc *	next;
	u_int32_t	prog;
	u_int32_t	vers;
	void		(*handler)(struct svc_req *, SVCXPRT *);
} SERVICE;

struct SVCXPRT {
	SVCXPRT *	next;
	SVCXPRT *	parent;
	int		fd;
	SERVICE *	service;
	unsigned int	running   : 1,
			receiving : 1;
	struct timeval	timeout;
	struct sockaddr_in addr;
	struct sockaddr_in peer;

	struct svc_rinfo {
		unsigned int	startofrecord : 1,
				morefrags     : 1;
		void *		buffer;
		u_int32_t	bufsize;
		u_int32_t	want;
		u_int32_t	have;
		u_int32_t	size;
		XDR		xdrs;
	}		rinfo;
	struct svc_sinfo {
		unsigned int	startofrecord : 1;
		void *		buffer;
		u_int32_t	bufsize;
		u_int32_t	sent;
		u_int32_t	size;
		struct rpc_msg	resp;
	}		sinfo;

	void		(*startrecv)(SVCXPRT *);
	void		(*receiver)(SVCXPRT *);
	void		(*startxmit)(SVCXPRT *, XDR *);
	void		(*sender)(SVCXPRT *);
};


#ifdef cplusplus
}
#endif

#endif /* _RPC_SVC_INT_H */
